GNU bug report logs - #26432
image-dired: Adding support for PDF thumbnails.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Keith David Bershatsky <esq@HIDDEN>; dated Mon, 10 Apr 2017 14:34:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 4 Aug 2020 09:12:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Aug 04 05:12:25 2020
Received: from localhost ([127.0.0.1]:46784 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1k2szg-0007hJ-TV
	for submit <at> debbugs.gnu.org; Tue, 04 Aug 2020 05:12:25 -0400
Received: from quimby.gnus.org ([95.216.78.240]:53780)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1k2szf-0007h6-Gz
 for 26432 <at> debbugs.gnu.org; Tue, 04 Aug 2020 05:12:24 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=ZCDWChAWDXtuvAwkLQOn/h5VJC/2UxTrpdTx3hRaoXM=; b=RqC96fy8YUdf7PbrE9NwBavQs+
 8NAAW2H31pj8IuQIF9qzukstxSFaTFdu8EwVPTYOlTPGsmcOYRZykimZcxJfXce7vGhPjgw5Iu3Uy
 br96ZE8XHkYEi+eKcnGgeRKt8EQwaShNK9eMNB/hYfXxNNxAmqHGMDUuPKbGXETZ8R2k=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1k2szP-00061a-5W; Tue, 04 Aug 2020 11:12:16 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Keith David Bershatsky <esq@HIDDEN>
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
References: <m27e4uhlg0.wl%esq@HIDDEN> <87blu6fjiv.fsf@HIDDEN>
Date: Tue, 04 Aug 2020 11:12:05 +0200
In-Reply-To: <87blu6fjiv.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Thu,
 24 Oct 2019 13:52:08 +0200")
Message-ID: <878seusrkq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Lars Ingebrigtsen <larsi@HIDDEN> writes: > Keith David
 Bershatsky
 <esq@HIDDEN> writes: > >> I understand that the Emacs development team
 would prefer a patch that >> uses the current system of start-process and
 run-at-time; however, >> [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 26432
Cc: 26432 <at> debbugs.gnu.org, Glenn Morris <rgm@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Keith David Bershatsky <esq@HIDDEN> writes:
>
>> I understand that the Emacs development team would prefer a patch that
>> uses the current system of start-process and run-at-time; however,
>> that would likely take me several more hours to figure out.
>
> Yeah, I think it would be better to try to use the current scaffolding.

Did you make any further progress here?  If I understand things
correctly, previously the thumbnail creation was more synchronous (with
call-process), and that made some times easier to work with, but
I think an asynchronous interface makes for a better user experience.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 24 Oct 2019 11:52:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 24 07:52:15 2019
Received: from localhost ([127.0.0.1]:35437 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iNbf5-0007GA-1y
	for submit <at> debbugs.gnu.org; Thu, 24 Oct 2019 07:52:15 -0400
Received: from quimby.gnus.org ([80.91.231.51]:60008)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iNbf3-0007Fz-0R
 for 26432 <at> debbugs.gnu.org; Thu, 24 Oct 2019 07:52:13 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iNbez-00041D-3c; Thu, 24 Oct 2019 13:52:11 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Keith David Bershatsky <esq@HIDDEN>
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
References: <m27e4uhlg0.wl%esq@HIDDEN>
Date: Thu, 24 Oct 2019 13:52:08 +0200
In-Reply-To: <m27e4uhlg0.wl%esq@HIDDEN> (Keith David Bershatsky's message
 of "Wed, 23 Oct 2019 20:27:43 -0700")
Message-ID: <87blu6fjiv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Keith David Bershatsky <esq@HIDDEN> writes: > I
 understand
 that the Emacs development team would prefer a patch that > uses the current
 system of start-process and run-at-time; however, > that would likely take
 me several more hours to figure o [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 26432
Cc: 26432 <at> debbugs.gnu.org, Glenn Morris <rgm@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Keith David Bershatsky <esq@HIDDEN> writes:

> I understand that the Emacs development team would prefer a patch that
> uses the current system of start-process and run-at-time; however,
> that would likely take me several more hours to figure out.

Yeah, I think it would be better to try to use the current scaffolding.

> In terms of me signing Emacs copyright papers and so forth, I would be
> happy to do that whenever the Emacs development team feels that I have
> a contribution that rises to a programming level worthy of Emacs.  At
> this time, my proof concept patch is far from being ready for
> production ....

But signing papers now doesn't -- it just makes things ready for a
future contribution.  I'll send you the form to get started off-list.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 24 Oct 2019 03:27:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 23 23:27:49 2019
Received: from localhost ([127.0.0.1]:35224 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iNTmu-0000u8-GT
	for submit <at> debbugs.gnu.org; Wed, 23 Oct 2019 23:27:49 -0400
Received: from gateway30.websitewelcome.com ([192.185.192.34]:48958)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <esq@HIDDEN>) id 1iNTmr-0000tz-TB
 for 26432 <at> debbugs.gnu.org; Wed, 23 Oct 2019 23:27:46 -0400
Received: from cm14.websitewelcome.com (cm14.websitewelcome.com [100.42.49.7])
 by gateway30.websitewelcome.com (Postfix) with ESMTP id 54ADB15AA8
 for <26432 <at> debbugs.gnu.org>; Wed, 23 Oct 2019 22:27:45 -0500 (CDT)
Received: from gator3053.hostgator.com ([50.87.144.69]) by cmsmtp with SMTP
 id NTmqiSTemBnGaNTmriSiCl; Wed, 23 Oct 2019 22:27:45 -0500
X-Authority-Reason: nr=8
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=lawlist.com
 ; s=default;
 h=Content-Type:MIME-Version:Subject:Cc:To:From:Message-ID:Date:
 Sender:Reply-To:Content-Transfer-Encoding:Content-ID:Content-Description:
 Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc:Resent-Message-ID:
 In-Reply-To:References:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=L0DbJTl8lPqGBEFU4BbmgF92F47gTldCPMJ8677b2uk=; b=hg3r1tsBYUgPuG1943TMUpFyGG
 pHaRnZxfN9SYCzeG/gvhtP5VAwSTKOJBub3j5Q7zZ8CE0bJwgEg4EDPXq0EJSj1UVjrGYTmZRl71h
 w6KDFlTRA7eNtN9ytE9/R5fScWdytn5ZxMSm6A5EvqucBbeMLbjpM5VXp3aANjZZXYvoQAiMoHLcI
 Rf5/QscAYQxhsBeM7KsY1Ck0QiPVdtvkO1boaNoPjkCPNeO8/c/RlDSwc0Qyh0wGzkViSTIEBHez4
 EL55G+qeKdbj2C0nosIVVLvFjQ7/fR7mwPh4LP+bTihqpb2MTjjbLd0xxDPmcrKJu4fVpsLxsSfN1
 OyB2TZUA==;
Received: from cpe-45-48-239-195.socal.res.rr.com ([45.48.239.195]:54753
 helo=server.local) by gator3053.hostgator.com with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.92)
 (envelope-from <esq@HIDDEN>)
 id 1iNTmq-003H6l-BH; Wed, 23 Oct 2019 22:27:44 -0500
Date: Wed, 23 Oct 2019 20:27:43 -0700
Message-ID: <m27e4uhlg0.wl%esq@HIDDEN>
From: Keith David Bershatsky <esq@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="Multipart_Wed_Oct_23_20:27:43_2019-1"
X-AntiAbuse: This header was added to track abuse,
 please include it with any abuse report
X-AntiAbuse: Primary Hostname - gator3053.hostgator.com
X-AntiAbuse: Original Domain - debbugs.gnu.org
X-AntiAbuse: Originator/Caller UID/GID - [47 12] / [47 12]
X-AntiAbuse: Sender Address Domain - lawlist.com
X-BWhitelist: no
X-Source-IP: 45.48.239.195
X-Source-L: No
X-Exim-ID: 1iNTmq-003H6l-BH
X-Source: 
X-Source-Args: 
X-Source-Dir: 
X-Source-Sender: cpe-45-48-239-195.socal.res.rr.com (server.local)
 [45.48.239.195]:54753
X-Source-Auth: lawlist
X-Email-Count: 2
X-Source-Cap: bGF3bGlzdDtsYXdsaXN0O2dhdG9yMzA1My5ob3N0Z2F0b3IuY29t
X-Local-Domain: yes
X-Spam-Score: 1.2 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: The attached proof concept patch applies to the master branch
 as of 10/23/2019 bearing commit 53e7a763dd16509d90418bdf14d161db13271ea3.
 I spent a couple of hours today fiddling around with a current version of
 image-dired.el, but I was not able to figure out how to get feature 26432
 to work properly. My problems had something do with [...] 
 Content analysis details:   (1.2 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnu.org]
 1.2 RCVD_IN_BL_SPAMCOP_NET RBL: Received via a relay in
 bl.spamcop.net
 [Blocked - see <https://www.spamcop.net/bl.shtml?192.185.192.34>]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [192.185.192.34 listed in list.dnswl.org]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
X-Debbugs-Envelope-To: 26432
Cc: 26432 <at> debbugs.gnu.org, Glenn Morris <rgm@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.2 (/)

--Multipart_Wed_Oct_23_20:27:43_2019-1
Content-Type: text/plain; charset=US-ASCII

The attached proof concept patch applies to the master branch as of 10/23/2019 bearing commit 53e7a763dd16509d90418bdf14d161db13271ea3.

I spent a couple of hours today fiddling around with a current version of image-dired.el, but I was not able to figure out how to get feature 26432 to work properly.  My problems had something do with the need for a return value from image-dired-create-thumb and the old way of doing things processed subprocesses consecutively using call-process, whereas the current way of doing things uses start-process and run-at-time ....  After unsuccessfully spinning my wheels, I went ahead and reverted the relevant functions in image-dired to where it was several years ago so that I could still use call-process and get a return value from image-dired-create-thumb; e.g., things like:

  (not (= 0 (image-dired-create-thumb file thumb-name)))

and

  (not (= 0 (image-dired-create-thumb curr-file thumb-name)))

I performed the following tests after applying the attached patch:

M-x image-dired:  On a directory containing a few PDF, PNG, JPG files.

M-x image-dired-dired-toggle-marked-thumbs:  In a dired-mode buffer containing a few PDF, PNG, JPG files.

In an *image-dired* buffer, move the cursor to different images and watch the files selection change in the corresponding dired-mode buffer.

In an *image-dired* buffer, press the enter key on an image and watch an *image-dired-display-image* buffer open with a larger image.

I understand that the Emacs development team would prefer a patch that uses the current system of start-process and run-at-time; however, that would likely take me several more hours to figure out.  In terms of me signing Emacs copyright papers and so forth, I would be happy to do that whenever the Emacs development team feels that I have a contribution that rises to a programming level worthy of Emacs.  At this time, my proof concept patch is far from being ready for production ....

Keith

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

> Date: [10-23-2019 03:03:29] <23 Oct 2019 12:03:29 +0200>
> From: Lars Ingebrigtsen <larsi@HIDDEN>
> To: Keith David Bershatsky <esq@HIDDEN>
> Cc: Drew Adams <drew.adams@HIDDEN>, 26432 <at> debbugs.gnu.org, Glenn Morris <rgm@HIDDEN>
> Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF thumbnails.)
> 
> Keith David Bershatsky <esq@HIDDEN> writes:
> 
> > Thank you Lars and Glenn for looking into tracker #26432.  I would be
> > pleased to look at this again in the coming days and see what changes
> > I made to the functions at issue to enable this particular feature.
> > My guess is that I only added a few lines of code to existing
> > functions.
> 
> Did you make any progress here?


--Multipart_Wed_Oct_23_20:27:43_2019-1
Content-Type: application/diff; type=patch
Content-Disposition: attachment; filename="2019_10_23__20_00_17_777.diff"
Content-Transfer-Encoding: base64
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--Multipart_Wed_Oct_23_20:27:43_2019-1--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.
Removed tag(s) moreinfo. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 23 Oct 2019 10:03:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 23 06:03:36 2019
Received: from localhost ([127.0.0.1]:60945 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iNDUO-0000fZ-97
	for submit <at> debbugs.gnu.org; Wed, 23 Oct 2019 06:03:36 -0400
Received: from quimby.gnus.org ([80.91.231.51]:34782)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iNDUM-0000fP-16
 for 26432 <at> debbugs.gnu.org; Wed, 23 Oct 2019 06:03:34 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iNDUI-0001lz-0r; Wed, 23 Oct 2019 12:03:32 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Keith David Bershatsky <esq@HIDDEN>
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
References: <m2vaqcjpu9.wl%esq@HIDDEN> <m21sszh9sh.wl%esq@HIDDEN>
 <iod1ci95vw.fsf@HIDDEN> <87k19rmhe5.fsf@HIDDEN>
 <913E673A-FE93-4CCF-89A3-C1C07B99A9E7@HIDDEN>
Date: Wed, 23 Oct 2019 12:03:29 +0200
In-Reply-To: <913E673A-FE93-4CCF-89A3-C1C07B99A9E7@HIDDEN> (Keith David
 Bershatsky's message of "Sun, 29 Sep 2019 09:57:52 -0700")
Message-ID: <87a79rixse.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Keith David Bershatsky <esq@HIDDEN> writes: > Thank you
 Lars and Glenn for looking into tracker #26432. I would be > pleased to look
 at this again in the coming days and see what changes > I made to the
 functions at issue to enable this particu [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 26432
Cc: 26432 <at> debbugs.gnu.org, Glenn Morris <rgm@HIDDEN>,
 Drew Adams <drew.adams@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Keith David Bershatsky <esq@HIDDEN> writes:

> Thank you Lars and Glenn for looking into tracker #26432.  I would be
> pleased to look at this again in the coming days and see what changes
> I made to the functions at issue to enable this particular feature.
> My guess is that I only added a few lines of code to existing
> functions.

Did you make any progress here?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 29 Sep 2019 16:57:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 29 12:57:57 2019
Received: from localhost ([127.0.0.1]:55747 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iEcWD-0001rS-4s
	for submit <at> debbugs.gnu.org; Sun, 29 Sep 2019 12:57:57 -0400
Received: from gateway31.websitewelcome.com ([192.185.143.234]:38926)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <esq@HIDDEN>) id 1iEcWA-0001rI-Sq
 for 26432 <at> debbugs.gnu.org; Sun, 29 Sep 2019 12:57:55 -0400
Received: from cm17.websitewelcome.com (cm17.websitewelcome.com [100.42.49.20])
 by gateway31.websitewelcome.com (Postfix) with ESMTP id 363F838FF
 for <26432 <at> debbugs.gnu.org>; Sun, 29 Sep 2019 11:57:54 -0500 (CDT)
Received: from gator3053.hostgator.com ([50.87.144.69]) by cmsmtp with SMTP
 id EcW9iNpVxPUvSEcWAi2OOg; Sun, 29 Sep 2019 11:57:54 -0500
X-Authority-Reason: nr=8
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=lawlist.com
 ; s=default;
 h=To:References:Message-Id:Content-Transfer-Encoding:Cc:Date:
 In-Reply-To:From:Content-Type:Mime-Version:Subject:Sender:Reply-To:Content-ID
 :Content-Description:Resent-Date:Resent-From:Resent-Sender:Resent-To:
 Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:List-Subscribe
 :List-Post:List-Owner:List-Archive;
 bh=6YZBO4wShc/fGr5sSLHFhRRnmzIzhAYBL+OwJdJdDUQ=; b=Ue+BsCu1PydO2wjB2DdVN2FTq2
 b74u9YjDFb+r2S2zGXNCG5g5fTlMXvpt7Z/7EE+ZYNRPhxNc1xJOJZo5OwoFWTIvxaytUSILy01QQ
 3A+MF/z9SvhgaXyo82g+Q48T1eqKkGlI031sJ9IJmLcDPiZRR9IcAPCPTQcFbojOCbORhIvsKTA4B
 L468oJtWV+V7vLg/kb8Rb3LaXpdaFbY5MyzTjY/NbshcOS9Ie5iO4dHID5syERdHrPBuKLtTjQaAD
 a6wxNAlpc0PddOucGXNGAwMQLIr4bOnevjRKRq4yDXkuFllmpmuS+68HhdKKT5CiCgZHWP2AC2XHO
 +G9vbT2w==;
Received: from cpe-45-48-239-195.socal.res.rr.com ([45.48.239.195]:49381
 helo=[192.168.0.3])
 by gator3053.hostgator.com with esmtpsa (TLSv1:ECDHE-RSA-AES128-SHA:128)
 (Exim 4.92) (envelope-from <esq@HIDDEN>)
 id 1iEcW9-002wQF-BU; Sun, 29 Sep 2019 11:57:53 -0500
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
Mime-Version: 1.0 (Apple Message framework v1084)
Content-Type: text/plain; charset=us-ascii
From: Keith David Bershatsky <esq@HIDDEN>
In-Reply-To: <87k19rmhe5.fsf@HIDDEN>
Date: Sun, 29 Sep 2019 09:57:52 -0700
Content-Transfer-Encoding: quoted-printable
Message-Id: <913E673A-FE93-4CCF-89A3-C1C07B99A9E7@HIDDEN>
References: <m2vaqcjpu9.wl%esq@HIDDEN> <m21sszh9sh.wl%esq@HIDDEN>
 <iod1ci95vw.fsf@HIDDEN> <87k19rmhe5.fsf@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>,
 Drew Adams <drew.adams@HIDDEN>
X-Mailer: Apple Mail (2.1084)
X-AntiAbuse: This header was added to track abuse,
 please include it with any abuse report
X-AntiAbuse: Primary Hostname - gator3053.hostgator.com
X-AntiAbuse: Original Domain - debbugs.gnu.org
X-AntiAbuse: Originator/Caller UID/GID - [47 12] / [47 12]
X-AntiAbuse: Sender Address Domain - lawlist.com
X-BWhitelist: no
X-Source-IP: 45.48.239.195
X-Source-L: No
X-Exim-ID: 1iEcW9-002wQF-BU
X-Source: 
X-Source-Args: 
X-Source-Dir: 
X-Source-Sender: cpe-45-48-239-195.socal.res.rr.com ([192.168.0.3])
 [45.48.239.195]:49381
X-Source-Auth: lawlist
X-Email-Count: 1
X-Source-Cap: bGF3bGlzdDtsYXdsaXN0O2dhdG9yMzA1My5ob3N0Z2F0b3IuY29t
X-Local-Domain: yes
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 26432
Cc: 26432 <at> debbugs.gnu.org, Glenn Morris <rgm@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Thank you Lars and Glenn for looking into tracker #26432.  I would be =
pleased to look at this again in the coming days and see what changes I =
made to the functions at issue to enable this particular feature.  My =
guess is that I only added a few lines of code to existing functions.

Drew:  I hope it is okay for me to add you to this discussion .....  In =
your dired+ adventures, have you already added support for displaying =
thumbnails of PDF files?

Keith

On Sep 29, 2019, at 5:11 AM, Lars Ingebrigtsen wrote:

> Glenn Morris <rgm@HIDDEN> writes:
>=20
>> Thanks. You can increase the chances of this being applied by sending =
it
>> as a patch (preferably against the latest version of Emacs from git),
>> and including the necessary commit message.
>>=20
>> Please note that if the changes are more than about 10 lines, a
>> copyright assignment would be needed.
>>=20
>> See
>> =
https://www.gnu.org/software/emacs/manual/html_node/emacs/Contributing.htm=
l
>> and references therein for more information.
>=20
> Keith, did you look into sending the change as a patch, and doing
> copyright assignments?  Otherwise it's unlikely that this feature is
> going to be added to Emacs.
>=20
> --=20
> (domestic pets only, the antidote for overdose, milk.)
>   bloggy blog: http://lars.ingebrigtsen.no





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.
Added tag(s) moreinfo. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 29 Sep 2019 12:11:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 29 08:11:36 2019
Received: from localhost ([127.0.0.1]:52495 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iEY36-0002pp-5L
	for submit <at> debbugs.gnu.org; Sun, 29 Sep 2019 08:11:36 -0400
Received: from quimby.gnus.org ([80.91.231.51]:53000)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iEY34-0002pf-SK
 for 26432 <at> debbugs.gnu.org; Sun, 29 Sep 2019 08:11:35 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iEY30-0000LE-Vr; Sun, 29 Sep 2019 14:11:33 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
References: <m2vaqcjpu9.wl%esq@HIDDEN> <m21sszh9sh.wl%esq@HIDDEN>
 <iod1ci95vw.fsf@HIDDEN>
Date: Sun, 29 Sep 2019 14:11:30 +0200
In-Reply-To: <iod1ci95vw.fsf@HIDDEN> (Glenn Morris's message of
 "Tue, 11 Apr 2017 14:05:39 -0400")
Message-ID: <87k19rmhe5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Glenn Morris <rgm@HIDDEN> writes: > Thanks. You can increase
 the chances of this being applied by sending it > as a patch (preferably
 against the latest version of Emacs from git), > and including the necessary
 commit message. > > Ple [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 26432
Cc: 26432 <at> debbugs.gnu.org, Keith David Bershatsky <esq@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Glenn Morris <rgm@HIDDEN> writes:

> Thanks. You can increase the chances of this being applied by sending it
> as a patch (preferably against the latest version of Emacs from git),
> and including the necessary commit message.
>
> Please note that if the changes are more than about 10 lines, a
> copyright assignment would be needed.
>
> See
> https://www.gnu.org/software/emacs/manual/html_node/emacs/Contributing.html
> and references therein for more information.

Keith, did you look into sending the change as a patch, and doing
copyright assignments?  Otherwise it's unlikely that this feature is
going to be added to Emacs.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 11 Apr 2017 18:06:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 11 14:06:06 2017
Received: from localhost ([127.0.0.1]:43241 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cy0B3-0007xl-00
	for submit <at> debbugs.gnu.org; Tue, 11 Apr 2017 14:06:06 -0400
Received: from eggs.gnu.org ([208.118.235.92]:46479)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rgm@HIDDEN>) id 1cy0B1-0007xI-2J
 for 26432 <at> debbugs.gnu.org; Tue, 11 Apr 2017 14:06:03 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <rgm@HIDDEN>) id 1cy0Av-00057g-6a
 for 26432 <at> debbugs.gnu.org; Tue, 11 Apr 2017 14:05:58 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_20,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:59923)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <rgm@HIDDEN>)
 id 1cy0Ad-0004yj-LM; Tue, 11 Apr 2017 14:05:39 -0400
Received: from rgm by fencepost.gnu.org with local (Exim 4.82)
 (envelope-from <rgm@HIDDEN>)
 id 1cy0Ad-00053r-8I; Tue, 11 Apr 2017 14:05:39 -0400
From: Glenn Morris <rgm@HIDDEN>
To: Keith David Bershatsky <esq@HIDDEN>
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
References: <m2vaqcjpu9.wl%esq@HIDDEN> <m21sszh9sh.wl%esq@HIDDEN>
X-Spook: basement Strain anthrax Transportation security Chemical
X-Ran: OA*S^B1TP-~nDC&@3\AAo3WwE28g9L}/}rdwg{;&Oj|)b0yNfzpV~g:;]]+T/S!ofwDr~f
X-Hue: white
X-Attribution: GM
Date: Tue, 11 Apr 2017 14:05:39 -0400
In-Reply-To: <m21sszh9sh.wl%esq@HIDDEN> (Keith David Bershatsky's message
 of "Mon, 10 Apr 2017 21:01:50 -0700")
Message-ID: <iod1ci95vw.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 26432
Cc: 26432 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)


Thanks. You can increase the chances of this being applied by sending it
as a patch (preferably against the latest version of Emacs from git),
and including the necessary commit message.

Please note that if the changes are more than about 10 lines, a
copyright assignment would be needed.

See
https://www.gnu.org/software/emacs/manual/html_node/emacs/Contributing.html
and references therein for more information.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.

Message received at 26432 <at> debbugs.gnu.org:


Received: (at 26432) by debbugs.gnu.org; 11 Apr 2017 04:01:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 11 00:01:58 2017
Received: from localhost ([127.0.0.1]:41832 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cxn09-0006hG-NF
	for submit <at> debbugs.gnu.org; Tue, 11 Apr 2017 00:01:57 -0400
Received: from gateway24.websitewelcome.com ([192.185.51.162]:14380)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <esq@HIDDEN>) id 1cxn06-0006h2-3n
 for 26432 <at> debbugs.gnu.org; Tue, 11 Apr 2017 00:01:54 -0400
Received: from cm3.websitewelcome.com (unknown [108.167.139.23])
 by gateway24.websitewelcome.com (Postfix) with ESMTP id 4DA0816664
 for <26432 <at> debbugs.gnu.org>; Mon, 10 Apr 2017 23:01:53 -0500 (CDT)
Received: from gator3053.hostgator.com ([50.87.144.69])
 by cm3.websitewelcome.com with 
 id 6s1r1v0171W3Awq01s1tk7; Mon, 10 Apr 2017 23:01:53 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=lawlist.com
 ; s=default;
 h=Content-Type:MIME-Version:Subject:To:From:Message-ID:Date:
 Sender:Reply-To:Cc:Content-Transfer-Encoding:Content-ID:Content-Description:
 Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc:Resent-Message-ID:
 In-Reply-To:References:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=Kp4DZrAnNwrybgkezeh5QaRwW/CzYRH7wsgHDvoMFPs=; b=OyiK8gOVQtunuN0YsdxIZuVFOI
 jj5VMCVDWlaSukMLxsvMeamGJQC39i6S+kn7XygbtoQcJw8ig4eUbCTWavbgoUNh9M3wUg4e9ldOL
 hHDw6MHCML9z/RaHAc1INTkjj5XsMrymnByUDPiYiynnayAmjIciDlAb4/lEA7ZuduopjFdyOwf0r
 M9RjvfaY8htjXu+nBinbN/ea+zLo5EP2c4O7gt0/XvArtF6BnTK/VaXhV8U/COqjJZOshoQd/nZie
 76vfofiR5tNqGQoafj+9aHLx19tPCht4L7XGow4iw9CwQ08pkM9grL41PENDhsZT2IHjIzsAnuVxv
 JNIyYr4Q==;
Received: from cpe-45-48-239-195.socal.res.rr.com ([45.48.239.195]:56981
 helo=server.local)
 by gator3053.hostgator.com with esmtpsa (TLSv1:DHE-RSA-AES256-SHA:256)
 (Exim 4.87) (envelope-from <esq@HIDDEN>) id 1cxn03-000XTw-Cv
 for 26432 <at> debbugs.gnu.org; Mon, 10 Apr 2017 23:01:51 -0500
Date: Mon, 10 Apr 2017 21:01:50 -0700
Message-ID: <m21sszh9sh.wl%esq@HIDDEN>
From: Keith David Bershatsky <esq@HIDDEN>
To: 26432 <at> debbugs.gnu.org
Subject: Re: bug#26432: Acknowledgement (image-dired: Adding support for PDF
 thumbnails.)
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
X-AntiAbuse: This header was added to track abuse,
 please include it with any abuse report
X-AntiAbuse: Primary Hostname - gator3053.hostgator.com
X-AntiAbuse: Original Domain - debbugs.gnu.org
X-AntiAbuse: Originator/Caller UID/GID - [47 12] / [47 12]
X-AntiAbuse: Sender Address Domain - lawlist.com
X-BWhitelist: no
X-Source-IP: 45.48.239.195
X-Exim-ID: 1cxn03-000XTw-Cv
X-Source: 
X-Source-Args: 
X-Source-Dir: 
X-Source-Sender: cpe-45-48-239-195.socal.res.rr.com (server.local)
 [45.48.239.195]:56981
X-Source-Auth: lawlist
X-Email-Count: 1
X-Source-Cap: bGF3bGlzdDtsYXdsaXN0O2dhdG9yMzA1My5ob3N0Z2F0b3IuY29t
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 26432
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)

In my own setup, I added the ability to detect the image size of the thumbnails and compare it to the current value of the image-dired width/height variables so that a new thumbnail will be created if the width/height of a stored cache thumbnail is different the current call.  For example, multiple thumbnails might be 100 pixels, but perhaps I want to see an 800 thumbnail of just the selected file.  This modification enables me to change the thumbnail image programmatically:

(defun image-dimensions (filename)
  (let* ((convert-program image-dired-cmd-create-thumbnail-program)
         (raw-dimensions
           (shell-command-to-string
             (concat convert-program " " "\"" filename "\"" " -ping -format \"%w x %h\" info:")))
         (list-dimensions
           (delete "x" (split-string raw-dimensions))))
    (cons
      (string-to-number (car list-dimensions))
      (string-to-number (cadr list-dimensions)))))

;;; ALTERNATIVE VERSION:

(defun image-dired-display-thumbs (&optional arg append do-not-pop)
  "Display thumbnails of all marked files, in `image-dired-thumbnail-buffer'.
If a thumbnail image does not exist for a file, it is created on the
fly.  With prefix argument ARG, display only thumbnail for file at
point (this is useful if you have marked some files but want to show
another one).

Recommended usage is to split the current frame horizontally so that
you have the dired buffer in the left window and the
`image-dired-thumbnail-buffer' buffer in the right window.

With optional argument APPEND, append thumbnail to thumbnail buffer
instead of erasing it first.

Optional argument DO-NOT-POP controls if `pop-to-buffer' should be
used or not.  If non-nil, use `display-buffer' instead of
`pop-to-buffer'.  This is used from functions like
`image-dired-next-line-and-display' and
`image-dired-previous-line-and-display' where we do not want the
thumbnail buffer to be selected."
  (interactive "P")
  (let ((buf (image-dired-create-thumbnail-buffer))
        thumb-name files dired-buf)
    (if arg
        (setq files (list (dired-get-filename)))
      (setq files (dired-get-marked-files)))
    (setq dired-buf (current-buffer))
    (with-current-buffer buf
      (let ((inhibit-read-only t))
        (if (not append)
            (erase-buffer)
          (goto-char (point-max)))
        (mapc
         (lambda (curr-file)
           (cond
             ((string-match (image-file-name-regexp) curr-file)
               (let* ((thumb-name (image-dired-thumb-name curr-file))
                      (thumbnail-dimensions
                        (when (file-exists-p thumb-name)
                          (image-dimensions thumb-name))))
                 (if (and
                        ;;; The goal is to move on to `image-dired-create-thumb' IF
                        ;;; the thumbnail exists and is the wrong size, or it does not exist.
                        (or (and (file-exists-p thumb-name)
                                 (not (or (= image-dired-thumb-width
                                             (car thumbnail-dimensions))
                                          (= image-dired-thumb-height
                                             (cdr thumbnail-dimensions))))
                                 (progn
                                   (clear-image-cache)
                                   'create-new-image))
                            (not (file-exists-p thumb-name)))
                        (not (= 0 (image-dired-create-thumb curr-file thumb-name))))
                   (message "Thumb could not be created for file %s" curr-file)
                   (image-dired-insert-thumbnail thumb-name curr-file dired-buf))))
             ((string-match "\\.\\(PDF\\)\\'" curr-file)
               (let* ((absolute-basename (file-name-sans-extension curr-file))
                      (png-filename (concat absolute-basename ".png"))
                      (pdf-first-page-filename (concat curr-file "[0]"))
                      (thumb-name (image-dired-thumb-name png-filename))
                      (thumbnail-dimensions
                        (when (file-exists-p thumb-name)
                          (image-dimensions thumb-name))))
                 (if (and
                        ;;; The goal is to move on to `image-dired-create-thumb' IF
                        ;;; the thumbnail exists and is the wrong size, or it does not exist.
                        (or (and (file-exists-p thumb-name)
                                 (not (or (= image-dired-thumb-width
                                             (car thumbnail-dimensions))
                                          (= image-dired-thumb-height
                                             (cdr thumbnail-dimensions))))
                                 (progn
                                   (clear-image-cache)
                                   'create-new-image))
                            (not (file-exists-p thumb-name)))
                        (not (= 0 (image-dired-create-thumb pdf-first-page-filename thumb-name))))
                     (message "Thumb could not be created for file %s" pdf-first-page-filename)
                   (image-dired-insert-thumbnail thumb-name pdf-first-page-filename dired-buf))))
             (t
               (message "%s does not match `image-file-name-regexp'" curr-file))))
         files))
      (cond ((eq 'dynamic image-dired-line-up-method)
             (image-dired-line-up-dynamic))
            ((eq 'fixed image-dired-line-up-method)
             (image-dired-line-up))
            ((eq 'interactive image-dired-line-up-method)
             (image-dired-line-up-interactive))
            ((eq 'none image-dired-line-up-method)
             nil)
            (t
             (image-dired-line-up-dynamic))))
    (if do-not-pop
        (display-buffer image-dired-thumbnail-buffer)
      (pop-to-buffer image-dired-thumbnail-buffer))))




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 Apr 2017 14:33:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 10 10:33:04 2017
Received: from localhost ([127.0.0.1]:41360 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1cxaNL-0001Uo-Vg
	for submit <at> debbugs.gnu.org; Mon, 10 Apr 2017 10:33:04 -0400
Received: from eggs.gnu.org ([208.118.235.92]:33198)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <esq@HIDDEN>) id 1cxaNI-0001UJ-PS
 for submit <at> debbugs.gnu.org; Mon, 10 Apr 2017 10:33:02 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <esq@HIDDEN>) id 1cxaN8-0006l6-SB
 for submit <at> debbugs.gnu.org; Mon, 10 Apr 2017 10:32:52 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,T_DKIM_INVALID
 autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:41368)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <esq@HIDDEN>) id 1cxaN8-0006l2-Oo
 for submit <at> debbugs.gnu.org; Mon, 10 Apr 2017 10:32:50 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:52400)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <esq@HIDDEN>) id 1cxaN6-0003bk-V4
 for bug-gnu-emacs@HIDDEN; Mon, 10 Apr 2017 10:32:50 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <esq@HIDDEN>) id 1cxaN3-0006k4-NZ
 for bug-gnu-emacs@HIDDEN; Mon, 10 Apr 2017 10:32:48 -0400
Received: from gateway30.websitewelcome.com ([192.185.151.58]:23041)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <esq@HIDDEN>) id 1cxaN3-0006gx-Bx
 for bug-gnu-emacs@HIDDEN; Mon, 10 Apr 2017 10:32:45 -0400
Received: from cm6.websitewelcome.com (cm6.websitewelcome.com [108.167.139.19])
 by gateway30.websitewelcome.com (Postfix) with ESMTP id E4E9E6C6F4
 for <bug-gnu-emacs@HIDDEN>; Mon, 10 Apr 2017 09:32:28 -0500 (CDT)
Received: from gator3053.hostgator.com ([50.87.144.69])
 by cm6.websitewelcome.com with 
 id 6eYF1v0071W3Awq01eYGtE; Mon, 10 Apr 2017 09:32:16 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=lawlist.com
 ; s=default;
 h=Content-Type:MIME-Version:Subject:To:From:Message-ID:Date:
 Sender:Reply-To:Cc:Content-Transfer-Encoding:Content-ID:Content-Description:
 Resent-Date:Resent-From:Resent-Sender:Resent-To:Resent-Cc:Resent-Message-ID:
 In-Reply-To:References:List-Id:List-Help:List-Unsubscribe:List-Subscribe:
 List-Post:List-Owner:List-Archive;
 bh=EGwrIJSZU/vgpUnw76Bp6XXsjCtm8lXmc/wYcG0MUkw=; b=YZgUUK43JwOUeH4QRg1jP0xOVm
 n626qCE1D7emu1zouuCjJ4qMhMxYKtr07q3yTOdwrhJ/Ic1hFLVvhQuTrDm1tnZK+DiyODleBgkJM
 DGrx1TrtJvcrGR0Y6p9p+lcFS2zcNAo2rYrpRA0Xff1Q4LChhf6rvO3tOboGMzKCVb4iS2kk+mqHo
 qtNCe108JnWiF6XkGu7DaTWZ8x+bAEMGoIBbtaNVtvd4VClZ4yZQFF9j+o70iqr50I2xLtTBQarn0
 Dhk2QjBCVMMiMhMb6r3pZhI7m4W7qxLqQu8D5soEobb+DcWfT8clye9nLJtPCkd3WcHbhCDcIClzW
 fUKtV/mA==;
Received: from cpe-45-48-239-195.socal.res.rr.com ([45.48.239.195]:49367
 helo=server.local)
 by gator3053.hostgator.com with esmtpsa (TLSv1:DHE-RSA-AES256-SHA:256)
 (Exim 4.87) (envelope-from <esq@HIDDEN>) id 1cxaMY-000CtF-NZ
 for bug-gnu-emacs@HIDDEN; Mon, 10 Apr 2017 09:32:14 -0500
Date: Mon, 10 Apr 2017 07:32:14 -0700
Message-ID: <m2vaqcjpu9.wl%esq@HIDDEN>
From: Keith David Bershatsky <esq@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: image-dired:  Adding support for PDF thumbnails.
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
X-AntiAbuse: This header was added to track abuse,
 please include it with any abuse report
X-AntiAbuse: Primary Hostname - gator3053.hostgator.com
X-AntiAbuse: Original Domain - gnu.org
X-AntiAbuse: Originator/Caller UID/GID - [47 12] / [47 12]
X-AntiAbuse: Sender Address Domain - lawlist.com
X-BWhitelist: no
X-Source-IP: 45.48.239.195
X-Exim-ID: 1cxaMY-000CtF-NZ
X-Source: 
X-Source-Args: 
X-Source-Dir: 
X-Source-Sender: cpe-45-48-239-195.socal.res.rr.com (server.local)
 [45.48.239.195]:49367
X-Source-Auth: lawlist
X-Email-Count: 1
X-Source-Cap: bGF3bGlzdDtsYXdsaXN0O2dhdG9yMzA1My5ob3N0Z2F0b3IuY29t
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

I posted the following answer on emacs.stackexchange.com, which adds the ability to display thumbnail images in image-dired:

http://emacs.stackexchange.com/questions/18151/thumbnail-previews-of-pdf-files

The Emacs team may wish to consider adding this ability at some point in the future:

(require 'image-dired)

;;; The `-flatten` argument makes a transparent PNG background white.
(setq image-dired-cmd-create-thumbnail-options
  "%p -size %wx%h \"%f\" -resize \"%wx%h>\" -flatten -strip jpeg:\"%t\"")

(defun image-dired-get-thumbnail-image (file)
  "Return the image descriptor for a thumbnail of image file FILE."
  (unless (or (string-match (image-file-name-regexp) file)
              (string-match "\\.\\(PDF\\)\\'" file))
    (error "%s is not a valid image file" file))
  (let ((thumb-file (image-dired-thumb-name file)))
    (unless (and (file-exists-p thumb-file)
     (<= (float-time (nth 5 (file-attributes file)))
         (float-time (nth 5 (file-attributes thumb-file)))))
      (image-dired-create-thumb file thumb-file))
    (create-image thumb-file)))

(defun image-dired-dired-toggle-marked-thumbs (&optional arg)
  "Toggle thumbnails in front of file names in the dired buffer.
If no marked file could be found, insert or hide thumbnails on the
current line.  ARG, if non-nil, specifies the files to use instead
of the marked files.  If ARG is an integer, use the next ARG (or
previous -ARG, if ARG<0) files."
  (interactive "P")
  (dired-map-over-marks
   (let* ((image-pos  (dired-move-to-filename))
          (image-file (dired-get-filename nil t))
          thumb-file
          overlay)
     (when (and image-file
                (or (string-match-p (image-file-name-regexp) image-file)
                    (string-match-p "\\.\\(PDF\\)\\'" image-file)))
       (setq thumb-file (image-dired-get-thumbnail-image image-file))
       ;; If image is not already added, then add it.
       (let* ((cur-ovs (overlays-in (point) (1+ (point))))
              (thumb-ov (car (cl-remove-if-not
                              (lambda (ov) (overlay-get ov 'thumb-file))
                              cur-ovs))))
         (if thumb-ov
             (delete-overlay thumb-ov)
     (put-image thumb-file image-pos)
     (setq overlay
                 (cl-loop for o in (overlays-in (point) (1+ (point)))
                          when (overlay-get o 'put-image) collect o into ov
                          finally return (car ov)))
     (overlay-put overlay 'image-file image-file)
     (overlay-put overlay 'thumb-file thumb-file)))))
   arg             ; Show or hide image on ARG next files.
   'show-progress) ; Update dired display after each image is updated.
  (add-hook 'dired-after-readin-hook
            'image-dired-dired-after-readin-hook nil t))

(defun image-dired-display-thumbs (&optional arg append do-not-pop)
  "Display thumbnails of all marked files, in `image-dired-thumbnail-buffer'.
If a thumbnail image does not exist for a file, it is created on the
fly.  With prefix argument ARG, display only thumbnail for file at
point (this is useful if you have marked some files but want to show
another one).

Recommended usage is to split the current frame horizontally so that
you have the dired buffer in the left window and the
`image-dired-thumbnail-buffer' buffer in the right window.

With optional argument APPEND, append thumbnail to thumbnail buffer
instead of erasing it first.

Optional argument DO-NOT-POP controls if `pop-to-buffer' should be
used or not.  If non-nil, use `display-buffer' instead of
`pop-to-buffer'.  This is used from functions like
`image-dired-next-line-and-display' and
`image-dired-previous-line-and-display' where we do not want the
thumbnail buffer to be selected."
  (interactive "P")
  (let ((buf (image-dired-create-thumbnail-buffer))
        thumb-name files dired-buf)
    (if arg
        (setq files (list (dired-get-filename)))
      (setq files (dired-get-marked-files)))
    (setq dired-buf (current-buffer))
    (with-current-buffer buf
      (let ((inhibit-read-only t))
        (if (not append)
            (erase-buffer)
          (goto-char (point-max)))
        (mapc
         (lambda (curr-file)
           (cond
             ((string-match (image-file-name-regexp) curr-file)
               (setq thumb-name (image-dired-thumb-name curr-file))
               (if (and (not (file-exists-p thumb-name))
                        (not (= 0 (image-dired-create-thumb
                                    curr-file thumb-name))))
                   (message "Thumb could not be created for file %s" curr-file)
                 (image-dired-insert-thumbnail thumb-name curr-file dired-buf)))
             ((string-match "\\.\\(PDF\\)\\'" curr-file)
               ;;; convert source.pdf[0] output.jpeg
               ;;; You can also select ranges, e.g., using source.pdf[0-3].
               (let* ((absolute-basename (file-name-sans-extension curr-file))
                      (png-filename (concat absolute-basename ".png"))
                      (pdf-first-page-filename (concat curr-file "[0]"))
                      (thumb-name (image-dired-thumb-name png-filename)))
                 (if (and (not (file-exists-p thumb-name))
                          (not (= 0 (image-dired-create-thumb
                                      pdf-first-page-filename thumb-name))))
                     (message "Thumb could not be created for file %s"
                              pdf-first-page-filename)
                   (image-dired-insert-thumbnail
                      thumb-name pdf-first-page-filename dired-buf))))
             (t
               (message "%s does not match `image-file-name-regexp'."
                        curr-file))))
         files))
      (cond ((eq 'dynamic image-dired-line-up-method)
             (image-dired-line-up-dynamic))
            ((eq 'fixed image-dired-line-up-method)
             (image-dired-line-up))
            ((eq 'interactive image-dired-line-up-method)
             (image-dired-line-up-interactive))
            ((eq 'none image-dired-line-up-method)
             nil)
            (t
             (image-dired-line-up-dynamic))))
    (if do-not-pop
        (display-buffer image-dired-thumbnail-buffer)
      (pop-to-buffer image-dired-thumbnail-buffer))))

(defun image-dired-show-all-from-dir (dir)
  "Make a preview buffer for all images in DIR and display it.
If the number of files in DIR matching `image-file-name-regexp'
exceeds `image-dired-show-all-from-dir-max-files', a warning will be
displayed."
  (interactive "DDir: ")
  (dired dir)
  (dired-mark-files-regexp (image-file-name-regexp))
  (dired-mark-files-regexp "\\.\\(PDF\\)\\'")
  (let ((files (dired-get-marked-files)))
    (if (or (<= (length files) image-dired-show-all-from-dir-max-files)
            (and (> (length files) image-dired-show-all-from-dir-max-files)
                 (y-or-n-p
                  (format
                   "Directory contains more than %d image files.  Proceed? "
                   image-dired-show-all-from-dir-max-files))))
        (progn
          (image-dired-display-thumbs)
          (pop-to-buffer image-dired-thumbnail-buffer))
      (message "Canceled."))))




Acknowledgement sent to Keith David Bershatsky <esq@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#26432; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 4 Aug 2020 09:15:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.